﻿using UnityEngine;
using System.Collections;

public class ai_manager : MonoBehaviour
{
    public Transform[] _team_r;
    public Transform[] _team_b;

    public Transform _ball;

	void Start()
    {
        foreach (Transform p in _team_r)
        {
            snowman sm = p.GetComponent<snowman>();
            sm.set_dir(1);
        }
    }

    void Update()
    {
        update_teams(_team_b);
        update_teams(_team_r);
    }

    public void reset()
    {
        foreach (Transform p in _team_b)
        {
            snowman sm = p.GetComponent<snowman>();
            sm.reset();
        }
        foreach (Transform p in _team_r)
        {
            snowman sm = p.GetComponent<snowman>();
            sm.reset();
        }
    }

    private void update_teams(Transform[] team)
    {
        bool team_owns_ball = false;

        float dist_to_ball = 9999f;
        Transform nearest_player = null;
        foreach (Transform p in team)
        {
            if (_ball.GetComponent<ball>()._owner == p)
                team_owns_ball = true;

            snowman sm = p.GetComponent<snowman>();
            if (!sm._is_player)
            {
                float new_dist = Vector3.Distance(_ball.transform.localPosition, p.localPosition);
                if (new_dist < dist_to_ball)
                {
                    dist_to_ball = new_dist;
                    nearest_player = p;
                }
            }
        }

        foreach (Transform p in team)
        {
            if (nearest_player == p)
            {
                snowman sm = nearest_player.GetComponent<snowman>();

                if (sm.has_ball())
                {
                    Vector3 to_goal = sm.get_goal().transform.localPosition - nearest_player.transform.localPosition;
                    float goal_dist = Vector3.Distance(nearest_player.transform.localPosition, sm.get_goal().transform.localPosition);
                    float team_member_dist = 999f;
                    Transform nearest_team_member = null;
                    foreach (Transform p2 in team)
                    {
                        if (nearest_player != p2)
                        {
                            float new_dist = Vector3.Distance(nearest_player.transform.localPosition, p2.localPosition);
                            if (new_dist < team_member_dist)
                            {
                                Vector3 to_team_member = p2.transform.localPosition - nearest_player.transform.localPosition;
                                if (Vector3.Dot(to_goal, to_team_member) > 0)
                                {
                                    team_member_dist = new_dist;
                                    nearest_team_member = p2;
                                }
                            }
                        }
                    }
                    if (goal_dist < team_member_dist)
                    {
                        nearest_player.SendMessage("shoot_at_goal", false);
                    }
                    else
                    {
                        if (team_member_dist <= 10f)
                            nearest_player.SendMessage("pass_to_team", nearest_team_member);
                        else
                            nearest_player.SendMessage("shoot_at_goal", true);
                    }
                }
                else
                {
                    nearest_player.SendMessage("move_to_ball", _ball);
                }
            }
            else
            {
                snowman sm = p.GetComponent<snowman>();
                if (!sm._is_player)
                {
                    move_data md = new move_data();
                    md.team_owns_ball = team_owns_ball;
                    md.nearest_player = nearest_player;
                    md.ball = _ball;
                    p.SendMessage("move_better_pos", md);
                }
            }
        }
    }

    public struct move_data
    {
        public bool team_owns_ball;
        public Transform nearest_player;
        public Transform ball;
    };
}
