﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class game : MonoBehaviour
{
    public ball _ball;
    public Transform _ball_start;
    
    public RectTransform _text_goals_t;
    private Text _text_goals;

    public RectTransform _text_time_t;
    private Text _text_time;

    private int[] _goals = { 0, 0};

    private float _game_time = 0f;
    private float _MAX_TIME = 270f;

    private bool _game_ended = false;

	void Start()
    {
        _text_goals = _text_goals_t.GetComponent<Text>();
        _text_time = _text_time_t.GetComponent<Text>();

        start_new_game();
	}
	
	void Update()
    {
        if (_game_time <= 0f)
        {
            _game_ended = true;
        }

        if (_game_ended)
        {
            update_result_text();
        }
        else
        {
            update_time_text();
        }
	}

    void FixedUpdate()
    {
        if (_game_ended)
        {
            if (Input.GetButtonDown("Kick"))
                StartCoroutine(reset_ball());                
        }
        else
        {
            _game_time -= Time.fixedDeltaTime;
        }
    }

    void start_new_game()
    {
        _goals[0] = _goals[1] = 0;

        update_goal_text();
        update_time_text();

        _game_time = _MAX_TIME;
        
        update_goal_text();

        _game_ended = false;
    }

    IEnumerator reset_ball()
    {
        yield return new WaitForSeconds(1);

        if (_game_ended)
            start_new_game();

        _ball.rigidbody2D.velocity = Vector2.zero;
        _ball.transform.localPosition = _ball_start.transform.localPosition;

        GetComponent<ai_manager>().reset();
    }

    void goal(int position)
    {
        if (!_game_ended)
        {
            _goals[1 - position]++;
            update_goal_text();
            StartCoroutine(reset_ball());
        }
    }

    void update_result_text()
    {
        _text_time.text = "Game Over";
        if (_goals[0] == _goals[1])
            _text_goals.text = "No team won!";
        else
            _text_goals.text = (_goals[0] > _goals[1] ? "Your team lost!" : "Your team won!");
    }

    void update_goal_text()
    {
        _text_goals.text = _goals[0] + " - " + _goals[1];
    }

    void update_time_text()
    {
        _text_time.text = _map_time(_game_time, _MAX_TIME, 0f, 90f, 0f).ToString("00.00");
    }

    private float _map_time(float t, float a, float b, float c, float d)
    {
        return c + (d - c) * ((t - a) / (b - a));
    }
}
